﻿using Syncfusion.Grouping;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Drawing.Drawing2D;

namespace checkbox_in_header_GGC
{
    public partial class Form1 : Form
    {
        private DataTable dt;
        private bool[] str = { true, false };
        Color hilight = SystemColors.ControlLightLight;
        Color shadow = SystemColors.ControlDarkDark;
        Syncfusion.Windows.Forms.XPThemes test = new XPThemes();
        public Form1()
        {
            InitializeComponent();

            #region DATASOURCE
            dt = new DataTable();
            dt.Columns.Add("Column1", typeof(string));
            dt.Columns.Add("Column2", typeof(string));
            dt.Columns.Add("Column3", typeof(string));
            dt.Columns.Add("Column4", typeof(string));
            dt.Columns.Add("Column5", typeof(string));

            Random r = new Random(123421);
            for (int row = 0; row < 20; row++)
            {
                DataRow dr = dt.NewRow();
                dr[0] = "row" + (row + 1) + "col1";
                dr[1] = "row" + (row + 1) + "col2";
                dr[2] = "row" + (row + 1) + "col3";
                dr[3] = "row" + (row + 1) + "col4";
                dr[4] = "row" + (row + 1) + "col5";
                dt.Rows.Add(dr);
            }
            #endregion

            this.gridGroupingControl1.DataSource = dt;

            this.gridGroupingControl1.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;

            #region Checkbox Settings
            this.gridGroupingControl1.QueryCellStyleInfo += new GridTableCellStyleInfoEventHandler(gridGroupingControl1_QueryCellStyleInfo);
            this.gridGroupingControl1.SaveCellText += new Syncfusion.Windows.Forms.Grid.GridCellTextEventHandler(gridGroupingControl1_SaveCellText);
            this.gridGroupingControl1.TableControlCellClick += new GridTableControlCellClickEventHandler(gridGroupingControl1_TableControlCellClick);
            this.gridGroupingControl1.TableControlCheckBoxClick += new GridTableControlCellClickEventHandler(gridGroupingControl1_TableControlCheckBoxClick);
            this.gridGroupingControl1.TableControl.MouseUp += new MouseEventHandler(TableControl_MouseUp);
            #endregion

            this.gridGroupingControl1.TableDescriptor.Columns["Column2"].Appearance.AnyRecordFieldCell.CellType = GridCellTypeName.CheckBox;
            this.gridGroupingControl1.TableDescriptor.Columns["Column2"].Appearance.AnyRecordFieldCell.Enabled = true;
            this.gridGroupingControl1.TableDescriptor.Columns["Column2"].Appearance.AnyRecordFieldCell.HorizontalAlignment = GridHorizontalAlignment.Center;
            //To set '0' and '1' instead of "True" and "False"
            this.gridGroupingControl1.TableDescriptor.Columns["Column2"].Appearance.AnyRecordFieldCell.CheckBoxOptions = new GridCheckBoxCellInfo("1", "0", "", true);

            //Add the custom cell type to cell models.
            this.gridGroupingControl1.TableModel.CellModels.Add("CustomCheckBox", new GridCustomCheckBoxCellModel(this.gridGroupingControl1.TableModel));

        }

        void TableControl_MouseUp(object sender, MouseEventArgs e)
        {
            int row, col;
            this.gridGroupingControl1.TableControl.PointToRowCol(new Point(e.X, e.Y), out row, out col);
            GridTableCellStyleInfo style = this.gridGroupingControl1.TableControl.Model[row, col];

            IMouseController controller;
            this.gridGroupingControl1.TableControl.MouseControllerDispatcher.HitTest(new Point(e.X, e.Y), e.Button, e.Clicks, out controller);

            if (controller != null && controller.Name == "DragGroupHeader")
            {
                if (this.gridGroupingControl1.TableDescriptor.GroupedColumns.Count > 0 && col == this.gridGroupingControl1.TableDescriptor.GroupedColumns.Count + 1)
                    this.gridGroupingControl1.TableControl.GetCellRenderer(row, col - this.gridGroupingControl1.TableDescriptor.GroupedColumns.Count).RaiseMouseUp(row, col - this.gridGroupingControl1.TableDescriptor.GroupedColumns.Count, e);
                else
                    this.gridGroupingControl1.TableControl.GetCellRenderer(row, col).RaiseMouseUp(row, col, e);

            }
        }

        string check;
        void gridGroupingControl1_TableControlCheckBoxClick(object sender, GridTableControlCellClickEventArgs e)
        {
            GridTableCellStyleInfo style = (GridTableCellStyleInfo)e.TableControl.GetTableViewStyleInfo(e.Inner.RowIndex, e.Inner.ColIndex);
            if (style.Enabled)
            {
                int column = this.gridGroupingControl1.TableModel.NameToColIndex("Column2");
                if (style.Enabled && style.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell)
                {
                    check = this.gridGroupingControl1.TableModel[style.TableCellIdentity.RowIndex, column].CellValue.ToString();
                    e.TableControl.BeginUpdate();
                    foreach (Record rec in e.TableControl.Table.Records)
                    {
                        int rowIndex = e.TableControl.Table.DisplayElements.IndexOf(rec);
                        GridTableCellStyleInfo rowStyle = (GridTableCellStyleInfo)e.TableControl.GetTableViewStyleInfo(rowIndex, column);
                        if (rowStyle.Enabled)
                        {
                            if (check == "0")
                                rec.SetValue("Column2", "1");
                            else
                                rec.SetValue("Column2", "0");
                        }
                    }
                    e.TableControl.EndUpdate(true);
                }
            }
            this.gridGroupingControl1.TableControl.Refresh();
        }

        void gridGroupingControl1_TableControlCellClick(object sender, GridTableControlCellClickEventArgs e)
        {
            GridTableCellStyleInfo style = e.TableControl.Model[e.Inner.RowIndex, e.Inner.ColIndex];
            if (style.Enabled)
            {
                if (style.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && style.TableCellIdentity.Column.Name == "Column2")
                {
                    e.Inner.Cancel = true;
                }
            }
        }

        object cellValue = "0";
        void gridGroupingControl1_SaveCellText(object sender, Syncfusion.Windows.Forms.Grid.GridCellTextEventArgs e)
        {
            GridTableCellStyleInfo style = (GridTableCellStyleInfo)e.Style;
            if (style.Enabled && style.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell)
            {
                cellValue = e.Text;
                e.Handled = true;
            }
        }

        void gridGroupingControl1_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
        {
            if (e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && e.TableCellIdentity.Column.Name == "Column2")
            {
                e.Style.CellType = "CustomCheckBox";
                e.Style.CellValue = cellValue;
                e.Style.CheckBoxOptions = new GridCheckBoxCellInfo("1", "0", "", true);
                e.Style.ReadOnly = false;
                e.Style.Enabled = true;
            }

            e.Handled = true;
        }
    }

    //Custom CheckBox
    public class GridCustomCheckBoxCellModel : GridCheckBoxCellModel
    {
        public GridCustomCheckBoxCellModel(GridModel grid)
            : base(grid)
        {
        }
        public override GridCellRendererBase CreateRenderer(GridControlBase control)
        {
            return new GridCustomCheckBoxCellRenderer(control, this);
        }
    }
    public class GridCustomCheckBoxCellRenderer : GridCheckBoxCellRenderer
    {
        public GridCustomCheckBoxCellRenderer(GridControlBase grid, GridCellModelBase cellModel)
            : base(grid, cellModel)
        {
        }
        protected override void OnDraw(Graphics g, Rectangle clientRectangle, int rowIndex, int colIndex, GridStyleInfo style)
        {
            string text = style.Description;
            Font font = style.GdipFont;
            ButtonState state = GetState(rowIndex, colIndex, style);
            ContentAlignment align = GridUtil.ConvertToContentAlignment(style.HorizontalAlignment)
                & GridUtil.ConvertToContentAlignment(style.VerticalAlignment);

            bool alignToRight = (style.TextAlign == GridTextAlign.Right) != Grid.IsRightToLeft();
            DrawCheckBox(g, clientRectangle, style, state, align, text, font);

            GridMargins margins = style.ReadOnlyTextMargins.ToMargins();
            if (Grid.IsRightToLeft())
            {
                margins = margins.SwapRightToLeft();
            }

            Rectangle textRectangle = GridMargins.RemoveMargins(clientRectangle, margins);
            Rectangle rc = clientRectangle;
            bool drawPressed = false;
            GridProperties propertyObject = Grid.Model.Properties;
            if (colIndex > 0 && (this.Grid.Selections.Ranges.AnyRangeIntersects(GridRangeInfo.Col(colIndex))
               || this.CurrentCell.ColIndex.Equals(colIndex)) && this.CurrentCell.IsActive && Grid.MarkColHeader)
                drawPressed = true;
            else if (this.CurrentCell.IsActive && Grid.MarkRowHeader && (this.Grid.Selections.Ranges.AnyRangeIntersects(GridRangeInfo.Row(rowIndex))
               || this.CurrentCell.RowIndex.Equals(rowIndex)))
                drawPressed = true;
            // Draw button look (if not pressed)
            if (style.CellAppearance == GridCellAppearance.Flat && propertyObject.Buttons3D)
            {
                Color shadow = SystemColors.ControlDarkDark;

                if (!Grid.PrintingMode)
                {
                    if ((style.Themed && XPThemes.IsThemedOS && XPThemes.IsThemeActive && this.Grid.ThemesEnabled)
                       || ((style.Themed && this.Grid.ThemesEnabled && ((this.Grid.Model.Options.GridVisualStyles != GridVisualStyles.SystemTheme)))))
                    {
                        Color hoverTextColor = Color.Empty, normalTextColor = Color.Empty, pressedTextColor = Color.Empty;
                        if (this.Grid.Model.Options.GridVisualStyles == GridVisualStyles.Metro || this.Grid.Model.Options.GridVisualStyles == GridVisualStyles.Office2010Black)
                            ((IThemeStyle)this.Grid.Model.Options.GridVisualStylesDrawing).GetHeaderTextColors(out normalTextColor, out hoverTextColor, out pressedTextColor);
                        ThemedHeaderDrawing.HeaderState state1 = ThemedHeaderDrawing.HeaderState.Normal;
                        GridRangeInfo cellRange = GridRangeInfo.Cell(rowIndex, colIndex);
                        Point mouseClientPosition = Grid.GetWindow().PointToClient(Control.MousePosition);
                        if (drawPressed && this.Grid.Model.Properties.MarkRowHeader)
                            state1 = ThemedHeaderDrawing.HeaderState.Pressed;
                        else if (drawPressed && this.Grid.Model.Properties.MarkColHeader)
                            state1 = ThemedHeaderDrawing.HeaderState.Pressed;
                        if ((this.Grid.Model.Options.GridVisualStyles == GridVisualStyles.Metro || this.Grid.Model.Options.GridVisualStyles == GridVisualStyles.Office2010Black)
                            && state1 == ThemedHeaderDrawing.HeaderState.Normal)
                        {
                            style.TextColor = normalTextColor;
                        }

                        bool isGroupCaption = this.Grid.Model.Options.GridVisualStyles == GridVisualStyles.Metro && style.CellIdentity.Info.StartsWith("GroupCaptionRow");

                        Grid.Model.Options.GridVisualStylesDrawing.DrawHeaderStyle(g, rc, state1);

                        if (state1 != ThemedHeaderDrawing.HeaderState.Normal)
                        {
                            Grid.NotifyCellHighlighted(rowIndex, colIndex, style);
                        }
                    }
                }
                else
                {
                    GridBorder border = new GridBorder(GridBorderStyle.Solid, Color.Black);
                    if (style.ReadOnlyBorders.Bottom.Style == GridBorderStyle.None
                        && propertyObject.DisplayHorzLines)
                    {
                        GridBorderPaint.DrawRectangle(g, border, clientRectangle, Color.White, GridBorderSide.Bottom);
                    }

                    if (style.ReadOnlyBorders.Right.Style == GridBorderStyle.None
                        && propertyObject.DisplayVertLines)
                    {
                        GridBorderPaint.DrawRectangle(g, border, clientRectangle, Color.White, GridBorderSide.Right);
                    }
                }
            }
            base.OnDraw(g, clientRectangle, rowIndex, colIndex, style);
        }
    }
}